var Collection, Model, events, inherits_,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

events = require('events');

inherits_ = require('inherits-underscore');

Model = require('./model');

module.exports = Collection = (function(superClass) {
  extend(Collection, superClass);

  inherits_(Collection.prototype);

  function Collection(name, models) {
    if (!name) {
      throw new Error('missing name');
    }
    this.name = name;
    this.models = [];
    [].concat(models).filter(Boolean).forEach((function(_this) {
      return function(x) {
        return _this.add(x);
      };
    })(this));
    Collection.__super__.constructor.call(this);
  }

  Collection.prototype._stripCollidingBindings = function(model, platform) {
    var checksum, collisions, keys, keysMethodName, list, sumMethodName;
    sumMethodName = "get" + platform + "Checksum";
    keysMethodName = "get" + platform + "Keys";
    list = this.chain().reject({
      name: model.name
    }).invoke(sumMethodName).flatten().without(void 0, null);
    checksum = model[sumMethodName]();
    collisions = list.intersection(checksum).value();
    keys = model[keysMethodName]();
    if (collisions.length) {
      if (model.readonly) {
        throw new Error("dup: " + model.name);
      } else {
        collisions = collisions.map(function(x) {
          return checksum.indexOf(x);
        });
        keys = keys.filter(function(x, i) {
          return !~collisions.indexOf(i);
        });
        return keys;
      }
    }
    return keys;
  };

  Collection.prototype._validateBindings = function(model) {
    return ['Win', 'Mac'].map((function(_this) {
      return function(platform) {
        return _this._stripCollidingBindings(model, platform);
      };
    })(this));
  };

  Collection.prototype.add = function(model) {
    if (!(model instanceof Model)) {
      model = new Model(model);
    }
    model.on('change', (function(_this) {
      return function() {
        return _this.emit('change', model);
      };
    })(this)).update({
      binding: this._validateBindings(model)
    }, true);
    this.models.push(model);
    return this;
  };

  Collection.prototype.update = function(name, value, silent) {
    var model;
    if (value == null) {
      value = {};
    }
    if (silent == null) {
      silent = false;
    }
    model = this.find({
      name: name
    });
    if (!(model instanceof Model)) {
      throw new Error(name + " not found");
    }
    model.update(value, true).update({
      binding: this._validateBindings(model)
    }, silent);
    return this;
  };

  Collection.prototype.toJSON = function() {
    return this.map(function(x) {
      return x.toJSON();
    });
  };

  return Collection;

})(events.EventEmitter);
